c_code { 
	#define PI 3.14159265 
	#define ROBORAD 20 
	#define OBRAD 10 
	#define AAL 11
	#define AAR 69 
	#define ADIST 8 
	#define SENLEN 80
	#define LAMBDA 1
	#define OMEGAP 15
	double obD = 0;
	double obA = 0;
	double theta = 0;
	double opp = 0;
	double adj = 0;
	double sAdj = 0;
	double hyp = 0;
	double sHyp = 0;
	double x = 0;
	double prevX = 0;
	double dOmegaD = 0;
	double oAMAX = 0;
	double lowR = 0;
	double highR = 0;
	double contactPoint = 0;	
	int i = 0;
	signed int flag = 0;

	int debug = 0;
};

#define AB_MOVE_FORWARD() c_code { \
if (debug==1) {printf("MOVE START: omegaD %d, sig %d, prevSig %d \n", now.omegaD, now.sig, now.prevSig);}\
	obD = (double) now.obDist; \
	obA = (double) now.obAng; \
	theta = fabs(obA - 40);  \
	adj = ( obD*cos(theta*(PI/180)) ); \
	opp = sqrt( (obD*obD) - (adj*adj) ); \
	adj = (adj - 1); \
	obD = sqrt( (opp*opp) + (adj*adj) ); \
	theta = (atan(opp/adj))*(180/PI); \
	if (obA < 40) { obA = 40 - theta; } \
	else { obA = 40 + theta; } \
	if ((obA < 0) | (obA >= 80)){ obA = 0; obD = 90; now.freeSpace = 1;} \
	now.obDist = ((int)(2*obD)) - ((int)obD); \
	now.obAng = ((int)(2*obA)) - ((int)obA); \
if (debug==1) {printf("MOVE END: omegaD %d, sig %d, prevSig %d \n", now.omegaD, now.sig, now.prevSig);}\
};
	
#define AB_RESPOND_TO_OB_BY_TURNING() c_code { \
if (debug==1) {printf("RESPOND START: omegaD %d, sig %d, prevSig %d \n", now.omegaD, now.sig, now.prevSig);}\
	obD = (double)now.obDist; \
	obA = (double)now.obAng; \
	dOmegaD = (double)now.omegaD; \
	oAMAX = (atan((OBRAD/obD)))*(180/PI); \
	lowR = (obA - oAMAX); \
	if (lowR < 0) { lowR = 0;} \
	highR = (obA + oAMAX); \
	if (highR > 80) { highR = 80;} \
	if ( (AAL >= lowR) & (AAL <= highR) ) { theta = fabs(AAL - obA); flag = -1;} \
	else if ( (AAR >= lowR) & (AAR <= highR) ) { theta = fabs(AAR - obA); flag = 1;} \
	else {flag = 0;} \
	opp = obD*(sin(theta*(PI/180)));\
	if ((flag != 0 ) && (opp <= OBRAD)) { \
		adj = sqrt((obD*obD) - (opp*opp)); \
		if (adj <= 80) { \
			for (i=0; i<=10; i++) {		\
				sAdj = OBRAD - i; \
				sHyp = sqrt((sAdj*sAdj) + (opp*opp));	 \
				if ((sHyp != 0) & (sHyp <= OBRAD)) { 	\
					contactPoint = adj - sAdj;		\
					x = (flag)*(ADIST - ( ( contactPoint-(((int)contactPoint)%10) )/10 )); \
					x = ((int)(2*x)) - ((int)x); \
					break; \
				} \
			} \
		} \
		else { x = 0;} \
	} \
	else { x = 0;} 	\
	if (fabs(x) > 5) { \
		obA = obA + (x*OMEGAP); \
		now.pLearn = 1; \
	} \
	else { obA = obA + (x*dOmegaD);} \
	if ((obA < 0) | (obA >= 80)) { now.freeSpace = 1;} \
	else { now.obAng = ((int)(2*obA)) - ((int)obA);} \
	now.prevSig = now.sig; \
	now.sig = (int)(fabs(x)); \
if (debug==1) {printf("RESPOND END: omegaD %d, sig %d, prevSig %d \n", now.omegaD, now.sig, now.prevSig);}\
};

#define AB_LEARN() c_code { \
if (debug==1) {printf("LEARN START: omegaD %d, sig %d, prevSig %d \n", now.omegaD, now.sig, now.prevSig);}\
	if ((now.pLearn == 1) && (fabs(prevX) > 0) && (fabs(prevX) <= 5)) { \
		now.omegaD = now.omegaD + LAMBDA; \
		now.freeSpace = 1; \
	} \
	now.pLearn = 0; \
	prevX = fabs(x); \
	/*now.prevSig = (int)(fabs(prevX));*/ \
if (debug==1) {printf("LEARN START: omegaD %d, sig %d, prevSig %d \n", now.omegaD, now.sig, now.prevSig);}\
};
