
#define PI 3.14159265
/*Conversion to Degrees factor = PI/180.*/
#define DEG 0.01745329
#define OBMINDIST 155
#define OBMINDIST 155

typedef struct {
	int d; /*Distance*/
	int a; /*Angle*/
} coord_t;
/*Array of the Obstacles*/
coord_t arrObs[2];
	
coord_t setCoord(int dist, int angle) {
	coord_t rtn;
	rtn.d = dist;
	rtn.a = angle;
	return rtn;
}


coord_t genOb(coord_t otherOb, int angFrom) {

	double roboA, enviD, enviA = 0;
	double oZ, nZ, fZ, lOrg, hOrg, lNew, hNew, lFin, hFin = 0;
	int oFR, oFU, nFR, nFU = 0;
	int i = 1; 

	coord_t rtnOb;
	rtnOb.a = 0;
	rtnOb.d = 0;

	/*Variables for the C code calculations (convert back to "int"s at the end)*/ 
	roboA = (double) angFrom; /*Angle ob is to previous one*/
	enviD = (double) otherOb.d;
	enviA = (double) otherOb.a;

	/*Triangle Original*/	
	oZ = ((int)enviA)%90;
	if ((enviA == 90) || (enviA ==270)) {lOrg = enviD; hOrg = 0; }
	else if ((enviA == 180) || (enviA == 0)) {lOrg = 0; hOrg = enviD; }
	else {
		if ((enviA <=90) || ((enviA >=180)&&(enviA<=270))) {
			lOrg = (sin(oZ*DEG))*enviD;
			hOrg = (cos(oZ*DEG))*enviD;
		} else {
			hOrg = (sin(oZ*DEG))*enviD;
			lOrg = (cos(oZ*DEG))*enviD;
		}
	}

	/*Triangle New*/
	/*Changed around h and l as I suspect they're wrong. CHECK CONVERSION FUNCTION.*/
	nZ = ((int)roboA)%90; 
	if ((roboA == 90) || (roboA ==270)) {lNew = OBMINDIST; hNew = 0; }
	else if ((roboA == 180) || (roboA == 0)) {lNew = 0; hNew = OBMINDIST; }
	else {
		if ((roboA <=90) || ((roboA >=180)&&(roboA<=270))) {
			lNew = (sin(nZ*DEG))*OBMINDIST;
			hNew = (cos(nZ*DEG))*OBMINDIST;
		} else {
			hNew = (sin(nZ*DEG))*OBMINDIST;
			lNew = (cos(nZ*DEG))*OBMINDIST;
		}
	}

	/*Triangle Final*/
	if ((enviA<180)&&(roboA>180) || (enviA>180)&&(roboA<180)) { lFin = fabs(lOrg - lNew);}
 	else { 	lFin = lOrg + lNew;}

	if ( (((enviA<90)||(enviA>270))&&((roboA>90)&&(roboA<270))) || (((enviA>90)&&(enviA<270))&&((roboA<90)||(roboA>270))) ) { 
		hFin = fabs(hOrg - hNew);
	} else { hFin = hOrg + hNew; }
	
	/**/
	if ((hFin!=0)&&(lFin!=0)) { fZ = (atan(hFin/lFin)*(180/PI)); }
	else { fZ = 0;}

	/*The new enviDist for the robot's new position*/
	enviD = sqrt((lFin*lFin)+(hFin*hFin));
/*There shall be no obs within 90 of the centre*/
if (enviD <= 90) {enviD = enviD+90;}
	
	/*Set up original Quadrant*/
	if ((enviA >=0) && (enviA <90))		 { oFR = 1; oFU = 1;}
	else if ((enviA >= 90) && (enviA <180))	 { oFR = 1; oFU = 0;}
	else if ((enviA >= 180) && (enviA <270)) { oFR = 0; oFU = 0;}
	else if ((enviA >= 270) && (enviA <360)) { oFR = 0; oFU = 1;}

	/*Assign default values incare we do not leave the current quadrant.*/
	nFR = oFR; nFU = oFU;
	/*Test to find the New quadrant that the FINAL coord is in.*/
	if ((oFR==1) && (oFU==1)) { 
		if ((roboA>=180) && (roboA<360) && (lNew > lOrg)) { nFR = 0;}
		if ((roboA>=90) && (roboA<270) && (hNew > hOrg))  { nFU = 0;}
	}
	else if ((oFR==1) && (oFU==0)) { 
		if ((roboA>=180) && (roboA<360) && (lNew > lOrg)) { nFR = 0;}
		if ( (((roboA>=270)&&(roboA<360))||((roboA>=0)&&(roboA<90))) && (hNew > hOrg)) { nFU = 1;}
	}
	else if ((oFR==0) && (oFU==0)) { 
		if ((roboA>=0) && (roboA<180) && (lNew > lOrg))   { nFR = 1;}
		if ( (((roboA>=270)&&(roboA<360))||((roboA>=0)&&(roboA<90))) && (hNew > hOrg)) { nFU = 1;}
	}
	else if ((oFR==0) && (oFU==1)) { 
		if ((roboA>=0) && (roboA<180) && (lNew > lOrg))   { nFR = 1;}
		if ((roboA>=90) && (roboA<270) && (hNew > hOrg))  { nFU = 0;}
	}

	/*Calc new enviA based on which quadrant that fZ is measured in. (fZ = atan(hFin/lFin).)*/
	if (roboA==enviA) { enviA = roboA;} /*Then angle doesn't change.*/
	else if ((nFR==1)&&(nFU==1)) { enviA = 90 - fZ;}
	else if ((nFR==1)&&(nFU==0)) { enviA = 90 + fZ;}
	else if ((nFR==0)&&(nFU==0)) { enviA = 270 - fZ;}
	else if ((nFR==0)&&(nFU==1)) { enviA = 270 + fZ;}

	/*x.5 and less, rounds down. Over this rounds up. 
	The rounding is neccessary because casting rounds down no matter what.*/
	rtnOb.d = ((int)(2*enviD)) - ((int)enviD);
	rtnOb.a = ((int)(2*enviA)) - ((int)enviA);
	
	/*Need to make sure that the angle doesn't exceed 359deg.*/
	if (rtnOb.a>=360) {rtnOb.a = 0;}	

	return rtnOb;
}


int testDist(coord_t thisOb, coord_t thatOb) {
	
	/*(enviDist, enviAng) are the coordinates of the Robot*/ 
	double roboEA, roboED, enviD, enviA, relD = 0;
	double oZ, nZ, fZ, lOrg, hOrg, lNew, hNew, lFin, hFin, fHyp, obD, obA = 0;
	int relDist = 0;

	/*Variables for the C code calculations (convert back to "int"s at the end)*/ 
	roboED = (double) thisOb.d; 
	roboEA = (double) thisOb.a; 
	obD = (double) thatOb.d; 
	obA = (double) thatOb.a; 

	/*Original Robot Triangle with Origin (Org)*/	
	oZ = ((int)roboEA)%90;
	if ((roboEA == 90) || (roboEA ==270)) {lOrg = roboED; hOrg = 0; }
	else if ((roboEA == 0) || (roboEA == 180)) {lOrg = 0; hOrg = roboED; }
	else {
		if ((roboEA <=90) || ((roboEA >=180)&&(roboEA<=270))) {
			lOrg = (sin(oZ*DEG))*roboED;
			hOrg = (cos(oZ*DEG))*roboED;
		} else {
			hOrg = (sin(oZ*DEG))*roboED;
			lOrg = (cos(oZ*DEG))*roboED;
		}
	}

	/*New Obstacle Triangle with Origin (New)*/
	nZ = ((int)obA)%90; 
	if ((obA == 90) || (obA ==270)) {lNew = obD; hNew = 0; }
	else if ((obA == 0) || (obA == 180)) {lNew = 0; hNew = obD; }
	else {
		if ((obA<90) || ((obA>180)&&(obA<270))) {
			lNew = (sin(nZ*DEG))*obD;
			hNew = (cos(nZ*DEG))*obD;
		} else {
			hNew = (sin(nZ*DEG))*obD;
			lNew = (cos(nZ*DEG))*obD;
		}
	}

	/*Final Distance Triangle between Robot and Obstacle (Final)*/
	if ((roboEA<180)&&(obA>180) || (roboEA>180)&&(obA<180)) { lFin = fabs(lOrg + lNew);}
 	else { 	lFin = lOrg - lNew;}

	if ( (((roboEA<90)||(roboEA>270))&&((obA>90)&&(obA<270))) || (((roboEA>90)&&(roboEA<270))&&((obA<90)||(obA>270))) ) { 
		hFin = fabs(hOrg + hNew);
	} else { hFin = hOrg - hNew; }

	/*The relDistance between the two coordinates*/
	relD = sqrt((lFin*lFin)+(hFin*hFin));
	relDist = ((int)(2*relD)) - ((int)relD); 

	return relDist;
}
